//
//  ALGraphics.h
//  ALKit
//
//  Created by Aaron Levine on 5/9/13.
//  Copyright (c) 2013 Aaron Levine. All rights reserved.
//

#pragma once
#ifndef ALKit_ALGraphics_h
#define ALKit_ALGraphics_h

    #import <Foundation/Foundation.h>
    #import "ShapeUtilities.h"

    #define ALKIT_TAB_HUE 0.6
    #define ALKIT_TAB_SATURATION 0.3
    #define ALKIT_TAB_BRIGHTNESS 0.6

#endif

@interface ALGraphics : UIView

@property (nonatomic, assign) CGFloat hue;
@property (nonatomic, assign) CGFloat saturation;
@property (nonatomic, assign) CGFloat brightness;

- (UIImage *)tabBarBackgroundImageWithRect:(CGRect)rect;
- (UIImage *)tabBarBackgroundSelectedImageWithRect:(CGRect)rect;
- (UIImage *)iconEmbededWithCGP:(NSString *)cgp Size:(CGFloat)size;
- (UIImage *)iconGlowingWithCGP:(NSString *)cgp Size:(CGFloat)size;
- (CGMutablePathRef)createRoundedRectForRect:(CGRect)rect Radius:(CGFloat)radius Panel:(NSInteger)panel;

static void evaluate (void *info, const float *in, float *out);
void drawLinearFade(CGContextRef context, CGRect rect, CGColorRef startColor);
void drawLinearGradient(CGContextRef context, CGRect rect, CGColorRef startColor, CGColorRef endColor);
void drawRadialGradient(CGContextRef context, CGRect rect, CGColorRef startColor, CGColorRef endColor);
void drawGlossAndGradient(CGContextRef context, CGRect rect, CGColorRef startColor, CGColorRef endColor);

@end

typedef NS_ENUM(NSInteger, ALPanelPosition) {
    ALPanelPositionUnbounded = 0,
    ALPanelPositionCenter = 1,
    ALPanelPositionLeft = 2,
    ALPanelPositionRight = 3,
    ALPanelPositionTop = 4,
    ALPanelPositionBottom = 5,
    ALPanelPositionTopLeft = 6,
    ALPanelPositionTopRight = 7,
    ALPanelPositionBottomLeft = 8,
    ALPanelPositionBottomRight = 9
};
