//
//  ALPanelViewController.m
//  ALKit_Multi_Example
//
//  Created by Aaron Levine on 6/6/13.
//  Copyright (c) 2013 Aaron Levine. All rights reserved.
//

#import "ALPanelViewController.h"

@interface ALPanelViewController ()

@property (nonatomic) ALPanel *panel;

@end

@implementation ALPanelViewController

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
     _panel = [[ALPanel alloc] initWithOrigin:CGPointMake(0, 0) numberOfViews:7 numberOfColumns:4 numberOfRows:3 dataSource:self];
    [self.view addSubview:_panel];
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (int)panel:(id)panel matrixIndexForColumn:(int)column Row:(int)row
{
    //NSLog(@"Matrix Index For Column Row");
    if (column == 0 && row != 2)
        return 0;
    else if (row == 0 && column != 0)
        return 1;
    else if (row == 1 && column != 0)
        return 2;
    else if (row == 2 && column == 0)
        return 3;
    else if (row == 2 && column == 1)
        return 4;
    else if (row == 2 && column == 2)
        return 5;
    else if (row == 2 && column == 3)
        return 6;
    
    else return -1;
}

- (CGFloat)panel:(id)panel widthForColumn:(int)column
{
    return 80;
}

- (CGFloat)panel:(id)panel heightForRow:(int)row
{
    return 40;
}

- (UIView *)panel:(id)panel viewForMatrixIndex:(int)index size:(CGSize)size
{
    UIView *view;
    ALPanelCell *cell;
    ALPanelButton *button;
    switch (index) {
        case 0:{
            cell = [[ALPanelCell alloc] initWithFrame:CGRectMake(0, 0, size.width, size.height)];
            view = cell;
            UIView *blackView = [[UIView alloc] initWithFrame:CGRectInset(cell.bounds, 5, 5)];
            blackView.backgroundColor = [UIColor blackColor];
            [view addSubview:blackView];
            break;}
            
        case 1:
            button = [[ALPanelButton alloc] init];
            [button setTitle:@"Name" forState:(UIControlState)nil];
            [button setTitleColor:[UIColor blackColor] forState:(UIControlState)nil];
            view = button;
            break;
            
        case 2:
            button = [[ALPanelButton alloc] init];
            [button setTitle:@"Location" forState:(UIControlState)nil];
            [button setTitleColor:[UIColor blackColor] forState:(UIControlState)nil];
            view = button;
            break;
            
        case 3:
            button = [[ALPanelButton alloc] init];
            [button setTitle:@"One" forState:(UIControlState)nil];
            [button setTitleColor:[UIColor blackColor] forState:(UIControlState)nil];
            view = button;
            break;
            
        case 4:
            button = [[ALPanelButton alloc] init];
            [button setTitle:@"Two" forState:(UIControlState)nil];
            [button setTitleColor:[UIColor blackColor] forState:(UIControlState)nil];
            view = button;
            break;
            
        case 5:
            button = [[ALPanelButton alloc] init];
            [button setTitle:@"Three" forState:(UIControlState)nil];
            [button setTitleColor:[UIColor blackColor] forState:(UIControlState)nil];
            view = button;
            break;
            
        case 6:
            button = [[ALPanelButton alloc] init];
            [button setTitle:@"Four" forState:(UIControlState)nil];
            [button setTitleColor:[UIColor blackColor] forState:(UIControlState)nil];
            view = button;
            break;
            
        default:
            view = [[UIView alloc] init];
            break;
    }
    return view;
}

@end
