//
//  ViewController.m
//  ALTextView-Sandbox
//
//  Created by Aaron Levine on 5/22/13.
//  Copyright (c) 2013 Aaron Levine. All rights reserved.
//

#import "ALTextViewWithLinks.h"

@interface ALTextViewWithLinks ()

@end

@implementation ALTextViewWithLinks

- (void)viewDidLoad
{
    [super viewDidLoad];

    [self.view setBackgroundColor:[UIColor whiteColor]];
    NSMutableAttributedString *attribString = [[NSMutableAttributedString alloc] initWithString:@"Lorem ipsum dolor sit amet, consectetuer adipiscing elit, sed diam nonummy nibh euismod tincidunt ut laoreet dolore magna aliquam erat volutpat. Ut wisi enim ad minim veniam, quis nostrud exerci tation ullamcorper suscipit lobortis nisl ut aliquip ex ea commodo consequat. Duis autem vel eum iriure dolor in hendrerit in vulputate velit esse molestie consequat, vel illum dolore eu feugiat nulla facilisis at vero eros et accumsan et iusto odio dignissim qui blandit praesent luptatum zzril delenit augue duis dolore te feugait nulla facilisi. Nam liber tempor cum soluta nobis eleifend option congue nihil imperdiet doming id quod mazim placerat facer possim assum. Typi non habent claritatem insitam; est usus legentis in iis qui facit eorum claritatem. Investigationes demonstraverunt lectores legere me lius quod ii legunt saepius. Claritas est etiam processus dynamicus, qui sequitur mutationem consuetudium lectorum. Mirum est notare quam littera gothica, quam nunc putamus parum claram, anteposuerit litterarum formas humanitatis per seacula quarta decima et quinta decima. Eodem modo typi, qui nunc nobis videntur parum clari, fiant sollemnes in futurum. Lorem ipsum dolor sit amet, consectetuer adipiscing elit, sed diam nonummy nibh euismod tincidunt ut laoreet dolore magna aliquam erat volutpat. Ut wisi enim ad minim veniam, quis nostrud exerci tation ullamcorper suscipit lobortis nisl ut aliquip ex ea commodo consequat. Duis autem vel eum iriure dolor in hendrerit in vulputate velit esse molestie consequat, vel illum dolore eu feugiat nulla facilisis at vero eros et accumsan et iusto odio dignissim qui blandit praesent luptatum zzril delenit augue duis dolore te feugait nulla facilisi. Nam liber tempor cum soluta nobis eleifend option congue nihil imperdiet doming id quod mazim placerat facer possim assum. Typi non habent claritatem insitam; est usus legentis in iis qui facit eorum claritatem. Investigationes demonstraverunt lectores legere me lius quod ii legunt saepius. Claritas est etiam processus dynamicus, qui sequitur mutationem consuetudium lectorum. Mirum est notare quam littera gothica, quam nunc putamus parum claram, anteposuerit litterarum formas humanitatis per seacula quarta decima et quinta decima. Eodem modo typi, qui nunc nobis videntur parum clari, fiant sollemnes in futurum. Lorem ipsum dolor sit amet, consectetuer adipiscing elit, sed diam nonummy nibh euismod tincidunt ut laoreet dolore magna aliquam erat volutpat. Ut wisi enim ad minim veniam, quis nostrud exerci tation ullamcorper suscipit lobortis nisl ut aliquip ex ea commodo consequat. Duis autem vel eum iriure dolor in hendrerit in vulputate velit esse molestie consequat, vel illum dolore eu feugiat nulla facilisis at vero eros et accumsan et iusto odio dignissim qui blandit praesent luptatum zzril delenit augue duis dolore te feugait nulla facilisi. Nam liber tempor cum soluta nobis eleifend option congue nihil imperdiet doming id quod mazim placerat facer possim assum. Typi non habent claritatem insitam; est usus legentis in iis qui facit eorum claritatem. Investigationes demonstraverunt lectores legere me lius quod ii legunt saepius. Claritas est etiam processus dynamicus, qui sequitur mutationem consuetudium lectorum. Mirum est notare quam littera gothica, quam nunc putamus parum claram, anteposuerit litterarum formas humanitatis per seacula quarta decima et quinta decima. Eodem modo typi, qui nunc nobis videntur parum clari, fiant sollemnes in futurum."];
    
    
    NSMutableParagraphStyle *pStyle = [[NSMutableParagraphStyle alloc] init];
    [pStyle setAlignment:NSTextAlignmentJustified];
    [attribString addAttribute:NSParagraphStyleAttributeName value:pStyle range:NSMakeRange(0, attribString.length)];
    [attribString addAttribute:NSFontAttributeName value:[UIFont fontWithName:@"Avenir Next" size:12.0] range:NSMakeRange(0, attribString.length)];
        
    NSMutableDictionary *linkAttribs = [[NSMutableDictionary alloc] init];
    [linkAttribs setObject:@"100" forKey:@"person"];
    [linkAttribs setObject:[UIColor blueColor] forKey:NSForegroundColorAttributeName];
    [linkAttribs setObject:[UIFont fontWithName:@"AvenirNext-DemiBold" size:12.0] forKey:NSFontAttributeName];
    [linkAttribs setObject:[NSNumber numberWithInt:NSUnderlineStyleSingle] forKey:NSUnderlineStyleAttributeName];
    [attribString addAttributes:linkAttribs range:NSMakeRange(100, 12)];
    
    linkAttribs = [[NSMutableDictionary alloc] init];
    [linkAttribs setObject:@"400" forKey:@"place"];
    [linkAttribs setObject:[UIColor blueColor] forKey:NSForegroundColorAttributeName];
    [linkAttribs setObject:[UIFont fontWithName:@"AvenirNext-DemiBold" size:12.0] forKey:NSFontAttributeName];
    [linkAttribs setObject:[NSNumber numberWithInt:NSUnderlineStyleSingle] forKey:NSUnderlineStyleAttributeName];
    [attribString addAttributes:linkAttribs range:NSMakeRange(400, 20)];
    
    CGRect textFrame = CGRectMake(10, 10, CGRectGetWidth(self.view.bounds) - 20, CGRectGetHeight(self.view.bounds) - 20);
    UIView *insetView = [[UIView alloc] initWithFrame:textFrame];
    [self.view addSubview:insetView];
    
    AlTextView *textView = [[AlTextView alloc] initWithFrame:insetView.bounds];
    [insetView addSubview:textView];
    [textView setText:attribString];
    [textView setDelegate:self];
    NSLog(@"height: %f", textView.estimatedHeight);
}

- (void)textView:(id)textView didSelectAttributeWithType:(NSString *)type Value:(id)value
{
    if ([type isEqualToString:@"person"] || [type isEqualToString:@"place"])
    {
        ALPopup *alert = [[ALPopup alloc] initWithText:[NSString stringWithFormat:@"You selected a %@ with value %@, and this is what shows up", type, value] Buttons:@"Okay", @"Cancel", @"Kancel", @"Again", @"and again", @"and again", @"One More", @"...", nil];
        [alert setDelegate:self];
        [alert setRadius:10];
        [alert show];
    }
}

- (void)popup:(id)popup didDismissWithIndex:(NSInteger)index
{
    NSLog(@"button index: %i", index);
}

@end
