//
//  ModelController.m
//  ALKit_Multi_Example
//
//  Created by Aaron Levine on 6/5/13.
//  Copyright (c) 2013 Aaron Levine. All rights reserved.
//

#import "ModelController.h"
#import "DataViewController.h"

#import "ALTextViewWithLinks.h"
#import "ALTextViewWithShape.h"
#import "ALPanelViewController.h"

@interface ModelController()
@property (readonly, strong, nonatomic) NSArray *pageData;
@end

@implementation ModelController

- (id)init
{
    self = [super init];
    if (self) {
        // Create the data model.
    }
    return self;
}

- (DataViewController *)viewControllerAtIndex:(NSUInteger)index storyboard:(UIStoryboard *)storyboard
{   
    DataViewController *dataViewController;
    
    switch (index) {
        case 0:
            dataViewController = [[ALTextViewWithLinks alloc] init];
            break;
            
        case 1:
            dataViewController = [[ALTextViewWithShape alloc] init];
            break;
            
        case 2:
            dataViewController = [[ALPanelViewController alloc] init];
            break;
            
        default:
            break;
    }
    
    dataViewController.index = index;
    return dataViewController;
}

- (NSUInteger)indexOfViewController:(DataViewController *)viewController
{   
    return viewController.index;
}

#pragma mark - Page View Controller Data Source

- (UIViewController *)pageViewController:(UIPageViewController *)pageViewController viewControllerBeforeViewController:(UIViewController *)viewController
{
    NSUInteger index = [self indexOfViewController:(DataViewController *)viewController];
    if ((index == 0) || (index == NSNotFound)) {
        return nil;
    }
    
    index--;
    return [self viewControllerAtIndex:index storyboard:viewController.storyboard];
}

- (UIViewController *)pageViewController:(UIPageViewController *)pageViewController viewControllerAfterViewController:(UIViewController *)viewController
{
    NSUInteger index = [self indexOfViewController:(DataViewController *)viewController];
    if (index == NSNotFound) {
        return nil;
    }
    
    index++;
    if (index == [self.pageData count]) {
        return nil;
    }
    return [self viewControllerAtIndex:index storyboard:viewController.storyboard];
}

@end
