//
//  ALPanel.h
//  ALKit
//
//  Created by Aaron Levine on 5/5/13.
//  Copyright (c) 2013 Aaron Levine. All rights reserved.
//

#pragma once
#ifndef Unity_Sandbox_ALPanel_h
#define Unity_Sandbox_ALPanel_h

    #define ALPANEL_DEFAULT_HUE 0.25
    #define ALPANEL_DEFAULT_SATURATION 0.0
    #define ALPANEL_DEFAULT_BRIGHTNESS 1.0
    #define ALPANEL_DEFAULT_RADIUS 6.0
    #define ALPANEL_DEFAULT_PANEL 0

    #import <UIKit/UIKit.h>
    #import <QuartzCore/QuartzCore.h>

    #import "ALPanelButton.h"
    #import "ALPanelCell.h"
    #import "ALGraphics.h"

#endif

//Object
@interface ALPanel : UIView

    @property (nonatomic, assign) CGFloat hue;
    @property (nonatomic, assign) CGFloat saturation;
    @property (nonatomic, assign) CGFloat brightness;
    @property (nonatomic, assign) CGFloat radius;

    @property (nonatomic, assign) CGPoint origin;
    @property (nonatomic, assign) int numViews;
    @property (nonatomic, assign) int numColumns;
    @property (nonatomic, assign) int numRows;

    @property (nonatomic) int **layoutMatrix;
    @property (nonatomic) NSArray *views;
    @property (nonatomic) ALPanelPosition *panelPerView;
    @property (nonatomic) id dataSource;

- (id)initWithOrigin:(CGPoint)origin numberOfViews:(int)numViews numberOfColumns:(int)numColumns numberOfRows:(int)numRows dataSource:(id)dataSource;

//- (ALPanelCell *)makePanelCellWithFrame:(CGRect)frame;
//- (ALPanelButton *)makePanelButtonWithFrame:(CGRect)frame title:(NSString *)title;

@end

//DataSource
@protocol ALPanelDataSource

- (UIView *)panel:(id)panel viewForMatrixIndex:(int)index size:(CGSize)size;
    - (CGFloat)panel:(id)panel widthForColumn:(int)column;
    - (CGFloat)panel:(id)panel heightForRow:(int)row;
    - (int)panel:(id)panel matrixIndexForColumn:(int)column Row:(int)row;

@end