//
//  ALPopup.h
//  ALKit
//
//  Created by Aaron Levine on 5/30/13.
//  Copyright (c) 2013 Aaron Levine. All rights reserved.
//

#pragma once
#ifndef ALKit_ALPopup_h
#define ALKit_ALPopup_h

    #import <UIKit/UIKit.h>
    #import <QuartzCore/QuartzCore.h>
    #import <CoreGraphics/CoreGraphics.h>
    #import "AlTextView.h"
    #import "ALPanel.h"

    #define ALPOPUP_WIDTH 282
    #define ALPOPUP_HUE 0.65
    #define ALPOPUP_RADIUS 5
    #define ALPOPUP_SATURATION 0.7
    #define ALPOPUP_BRIGHTNESS 0.2
    #define ALPOPUP_ALPHA 0.85
    #define ALPOPUP_FONT @"AvenirNext-Bold"
    #define ALPOPUP_FONT_SIZE 14

#endif

@class ALPopup;

@protocol ALPopupDelegate

- (void) popup:(id)popup didDismissWithIndex:(NSInteger)index;

@end

@interface ALPopup : UIView

@property (nonatomic) CGFloat width;
@property (nonatomic) CGFloat hue;
@property (nonatomic) CGFloat radius;
@property (nonatomic) CGFloat saturation;
@property (nonatomic) CGFloat brightness;
@property (nonatomic) CGFloat pAlpha;
@property (nonatomic) NSString *font;
@property (nonatomic) CGFloat fontSize;

@property (nonatomic) id delegate;

@property (nonatomic, strong) UIWindow *window;
@property (nonatomic) AlTextView *textView;
@property (nonatomic) CGRect textFrame;
@property (nonatomic) NSArray *buttons;

- (void)show;
- (void)hide;

- (id) initWithText:(NSString *)text Buttons:(NSString *)buttons, ... NS_REQUIRES_NIL_TERMINATION;

@end
