//
//  AlTextView.h
//  ALKit
//
//  Created by Aaron Levine on 5/22/13.
//  Copyright (c) 2013 Aaron Levine. All rights reserved.
//

#pragma once
#ifndef ALKit_ALTextView_h
#define ALKit_ALTextView_h

    #import <UIKit/UIKit.h>
    #import <CoreText/CoreText.h>

#endif

@class AlTextView;

//==========Delegate==========

@protocol ALTextViewDelegate

- (void)textView:(id)textView didSelectAttributeWithType:(NSString *)type Value:(id)value;

@end

//==========Object==========

@interface AlTextView : UIView

@property (nonatomic) CGPathRef path;
@property (nonatomic) NSAttributedString *text;
@property (nonatomic, assign) CTFrameRef textFrame;
@property (nonatomic) CGFloat height;
@property (nonatomic) CGFloat width;
@property (nonatomic, assign) id delegate;

- (id)initWithPath:(CGPathRef)initPath;
- (void)setPath:(CGPathRef)newPath;
- (void)setDelegate:(id)newDelegate;
- (id)delegate;
- (void)setText:(NSAttributedString *)text;

- (CGFloat)estimatedHeight;

@end
